FlamingLoot = LibStub("AceAddon-3.0"):NewAddon("FlamingLoot", "AceConsole-3.0", "AceEvent-3.0")

--VARIABLES
local lootTable = {{}} --[#].name, rollopts, texture, link, selec, msg; items added in StartLooting, removed in RollonItem
local masterlooter = ""
local currentitem = 1
local lootcount = 0
local rolloptsTable = {}
local rollingopen = false
local playerclass = UnitClass("player")
local optsdisplay = {
	["n"] = "need",
	["s"] = "sidegrade",
	["o"] = "offspec",
	["g"] = "greed",
	["p"] = "pass",
	}
	
--INITIALIZE & ONLOAD
function FlamingLoot:OnInitialize()
	RegisterAddonMessagePrefix("flamingloot")
end

function FlamingLoot:OnEnable()
	self:Print("FlamingLoot addon loaded.")
	self:RegisterEvent("CHAT_MSG_ADDON")
	self:RegisterChatCommand("flhide", "HideFrames")
end

function FlamingLoot:HideFrames()
	FLLootRollFrame:Hide() 
 end

local fra = CreateFrame("Frame", "FLR_ItemCachingFrame")
local interval = 0
--MAIN FUNCS
function FlamingLoot:StartLooting(sender, param)
	--format: "item:id=rolltype; item name=rolltype; etc"
	FLR_ItemCachingFrame:Show()
	lootcount = 0
	--self:Print("looting started")
	rollingopen = true
	masterlooter = sender
	local eq, _ = string.find(param, "=")
	local semi = 0
	while eq do
		lootcount = lootcount+1
		if not lootTable[lootcount] then --only make a new table if we haven't already
			lootTable[lootcount] = {}
		end
		lootTable[lootcount]["itemid"] = tonumber(string.sub(param, semi+1, eq-1))
		semi, _ = string.find(param, ";", eq)
		lootTable[lootcount]["rollopts"] = string.sub(param, eq+1, semi-1)
		eq, _ = string.find(param, "=", semi)
		--self:Print("item number "..lootcount.." - id is "..lootTable[lootcount]["itemid"]..", roll opts are "..lootTable[lootcount]["rollopts"]) --DEBUG
	end
end
local done = false
	
local function GetLootInfo(self, elapsed)
	interval = interval + elapsed
	if interval>.5 and lootTable[1].itemid then
		done = true
		for i, itemtable in pairs(lootTable) do
			if not lootTable[i].name then 
				--FlamingLoot:Print("looking up item id "..itemtable.itemid)
				local test = GetItemInfo(itemtable.itemid)
				if not test then
					done = false
				else
					itemtable["name"] = select(1, test)
					--FlamingLoot:Print("Name is "..itemtable.name)
				end
			end
		end
		if done==true then
			--FlamingLoot:Print("done!")
			fra:Hide()
			FlamingLoot:ProcessLoot()
		end
		interval = 0
	end
end
fra:SetScript("OnUpdate", GetLootInfo)
fra:Hide()

function FlamingLoot:ProcessLoot()
	for i=1, lootcount do
		local iname, ilink, _, ilvl, _, class, subtype, _, equipSlot, texture, _ = GetItemInfo(lootTable[i].itemid)
		--self:Print("item number "..i.."name is "..iname..", link is "..ilink) --debug
		lootTable[i]["name"] = iname
		subtype = subtype or ""
		if equipSlot=="INVTYPE_CLOAK" then subtype="Cloak" end
		self:Print(ilink..class.." "..subtype.." "..equipSlot)
		if string.find(lootTable[i].rollopts, "n") and FlamingLoot:DetermineAutopass(subtype) then
			lootTable[i].selec = "a"
		else  --TODO add func to come up with most relevant text
			lootTable[i]["subtype"] = subtype
			wipe(rolloptsTable)
			local optsstr = lootTable[i].rollopts
			lootTable[i]["link"] = ilink
			lootTable[i]["texture"] = texture
			for i=1, #optsstr do
				rolloptsTable[i] = string.sub(optsstr, i, i)
			end
		lootTable[i].rollopts = rolloptsTable --FIX not sure
		end
	end
	FlamingLoot:LootNextItem() 
end

function FlamingLoot:LootNextItem()
	if lootTable[currentitem].selec then
		FlamingLoot:RollonItem(lootTable[currentitem].selec)
	else
		FLLootRollFrameItem:SetScript("OnEnter", function(self, motion) FlamingLoot:ShowTooltip(FLLootRollFrameItem, lootTable[currentitem].link, "ANCHOR_RIGHT") end)
		FLLootRollFrameItem:SetScript("OnLeave", function(self, motion) GameTooltip:Hide() end)
		FLLootRollFrameItem:SetNormalTexture(lootTable[currentitem].texture)
		FLLootRollFrameItemLink:SetText(lootTable[currentitem].link)
		--FLLootRollFrameItemType:SetText(lootTable[currentitem].subtype)
		FLLootRollFrameButton1:SetText(optsdisplay[lootTable[currentitem].rollopts[1]])
		FLLootRollFrameButton1:SetScript("OnClick", function() FlamingLoot:RollonItem(lootTable[currentitem].rollopts[1]) end)
		FLLootRollFrameButton2:SetText(optsdisplay[lootTable[currentitem].rollopts[2]])
		FLLootRollFrameButton2:SetScript("OnClick", function() FlamingLoot:RollonItem(lootTable[currentitem].rollopts[2]) end)
		if lootTable[currentitem].rollopts[3] then
			FLLootRollFrameButton3:SetText(optsdisplay[lootTable[currentitem].rollopts[3]])
			FLLootRollFrameButton3:SetScript("OnClick", function() FlamingLoot:RollonItem(lootTable[currentitem].rollopts[3]) end)
			FLLootRollFrameButton3:Show()
		end
		if lootTable[currentitem].rollopts[4] then
			FLLootRollFrameButton4:SetScript("OnClick", function() FlamingLoot:RollonItem(lootTable[currentitem].rollopts[4]) end)
			FLLootRollFrameButton4:SetText(optsdisplay[lootTable[currentitem].rollopts[4]])
			FLLootRollFrameButton4:Show()
		end
		FLLootRollFrame:Show()
	end
end

function FlamingLoot:RollonItem(button)
	--"item name=rolltype;roll#"
	lootTable[currentitem].msg = "roll:"..lootTable[currentitem].name.."="..button
	if button~="a" then self:Print("You rolled "..optsdisplay[button].." on "..lootTable[currentitem].link)
	else FlamingLoot:Print("Auto-passed on "..lootTable[currentitem].name) end 
	if button == "o" or button =="g" or button =="s" or button =="r" then
		local roll = tostring(math.random(100))
		self:Print("Random roll: "..roll)
		lootTable[currentitem].msg = lootTable[currentitem].msg..";"..roll
	end
	SendAddonMessage("flamingloot", lootTable[currentitem].msg, "WHISPER", masterlooter);
	FLLootRollFrame:Hide()
	wipe(lootTable[currentitem])
	if currentitem<lootcount then
		currentitem = currentitem+1
		if rollingopen==true then FlamingLoot:LootNextItem() end
    else
		lootcount = 0
		currentitem = 1
	end
end

function FlamingLoot:EndLooting()
	self:Print("Loot rolling closed.")
	FLLootRollFrame:Hide()
	rollingopen = false
	for i= currentitem, lootcount do --if looting was ended before we rolled on everything, clear the rest of the loottable
		FlamingLoot:RollonItem("a")
	end
end

--ADDON MESSAGE HANDLER
function FlamingLoot:CHAT_MSG_ADDON(event, prefix, message, channel, sender)
	if (prefix == "flamingloot") then
		local colon = strfind(message,":");
		local command = strsub(message,1, colon - 1)
		local param
		if #message>colon then 
			param = strsub(message, colon + 1)
		end
		if command == "loot" then
			FlamingLoot:StartLooting(sender,param)
		elseif command =="end" then
			FlamingLoot:EndLooting()
		elseif command=="Print" then
			FlamingLoot:Print(param)
		end
	end
end

--UTILITY FUNCS/LOOKUPS
	
local disallowed = { --code taken from liblootutils (included with epgp)
   Deathknight = {
     Leather = true,
     Mail = true,
      Cloth = true,
     Shields = true,
     Bows = true,
     Crossbows = true,
     Daggers = true,
     ["Fist Weapons"] = true,
     Guns = true,
     Polearms = true,
     Staves = true,
     Idols = true,
     Librams = true,
     Thrown = true,
     Totems = true,
     Wands = true,
   },
   Druid = {
    Cloth = true,
     Mail = true,
     Plate = true,
     Plate = true,
     Shields = true,
     Bows = true,
     Crossbows = true,
     Guns = true,
     ["One-Handed Axes"] = true,
     ["One-Handed Swords"] = true,
     ["Two-Handed Axes"] = true,
     ["Two-Handed Swords"] = true,
     Librams = true,
     Sigils = true,
     Thrown = true,
     Totems = true,
     Wands = true,
   },
   Hunter= {
   Leather = true,
    Cloth = true,
     Plate = true,
     Shields = true,
     ["One-Handed Maces"] = true,
     ["Two-Handed Maces"] = true,
     Idols = true,
     Librams = true,
     Sigils = true,
     Totems = true,
     Wands = true,
   },
   Mage = {
     Leather = true,
     Mail = true,
     Plate = true,
     Shields = true,
     Bows = true,
     Crossbows = true,
     ["Fist Weapons"] = true,
     Guns = true,
     ["One-Handed Axes"] = true,
     ["One-Handed Maces"] = true,
     Polearms = true,
     ["Two-Handed Axes"] = true,
     ["Two-Handed Maces"] = true,
     ["Two-Handed Swords"] = true,
     Idols = true,
     Librams = true,
     Sigils = true,
     Thrown = true,
     Totems = true,
   },
	Paladin = {
		Leather = true,
		Mail = true,
		Cloth = true,
		Bows = true,
		Crossbows = true,
		["Fist Weapons"] = true,
		Guns = true,
		Staves = true,
		Idols = true,
		Sigils = true,
		Thrown = true,
		Totems = true,
		Wands = true,
   },
	Priest = {
		Leather = true,
		Mail = true,
		Plate = true,
		Shields = true,
		Bows = true,
		Crossbows = true,
		["Fist Weapons"] = true,
		Guns = true,
		["One-Handed Axes"] = true,
		["One-Handed Swords"] = true,
		Polearms = true,
		["Two-Handed Axes"] = true,
		["Two-Handed Maces"] = true,
		["Two-Handed Swords"] = true,
		Idols = true,
		Librams = true,
		Sigils = true,
		Thrown = true,
		Totems = true,
	},
   Rogue = {
    Leather = true,
     Mail = true,
     Plate = true,
     Shields = true,
     Polearms = true,
     Staves = true,
     ["Two-Handed Axes"] = true,
     ["Two-Handed Maces"] = true,
     ["Two-Handed Swords"] = true,
     Idols = true,
     Librams = true,
     Sigils = true,
     Totems = true,
     Wands = true,
   },
   Shaman = {
     Plate = true,
   Leather = true,
    Cloth = true,
     Bows = true,
     Crossbows = true,
     Guns = true,
     ["One-Handed Swords"] = true,
     Polearms = true,
     ["Two-Handed Swords"] = true,
     Idols = true,
     Librams = true,
     Sigils = true,
     Thrown = true,
     Wands = true,
   },
   Warlock = {
     Leather = true,
     Mail = true,
     Plate = true,
     Shields = true,
     Bows = true,
     Crossbows = true,
     ["Fist Weapons"] = true,
     Guns = true,
     ["One-Handed Axes"] = true,
     ["One-Handed Maces"] = true,
     Polearms = true,
     ["Two-Handed Axes"] = true,
     ["Two-Handed Maces"] = true,
     ["Two-Handed Swords"] = true,
     Idols = true,
     Librams = true,
     Sigils = true,
     Thrown = true,
     Totems = true,
   },
   Warrior = {
     Leather = true,
     Mail = true,
    Cloth = true,
     Idols = true,
     Librams = true,
     Sigils = true,
     Totems = true,
     Wands = true,
   },
 }

function FlamingLoot:DetermineAutopass(subtype) --returns true if autopass, false if not
	if not subtype then
      return false
	elseif disallowed[playerclass][subtype] then
      return true
	else
	return false
	end
end

function FlamingLoot:ShowTooltip(owner, itemlink, position)
   GameTooltip:SetOwner(owner, position)
   GameTooltip:SetHyperlink(itemlink)
   GameTooltip:Show()
end